package cn.ibizlab.assetmanagement.core.plan.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.plan.domain.EAMPlanCDT;
import cn.ibizlab.assetmanagement.core.plan.filter.EAMPlanCDTSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMPlanCDT] 服务对象接口
 */
public interface IEAMPlanCDTService extends IService<EAMPlanCDT>{

    boolean create(EAMPlanCDT et) ;
    void createBatch(List<EAMPlanCDT> list) ;
    boolean update(EAMPlanCDT et) ;
    void updateBatch(List<EAMPlanCDT> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMPlanCDT get(String key) ;
    EAMPlanCDT getDraft(EAMPlanCDT et) ;
    boolean checkKey(EAMPlanCDT et) ;
    boolean save(EAMPlanCDT et) ;
    void saveBatch(List<EAMPlanCDT> list) ;
    Page<EAMPlanCDT> searchDefault(EAMPlanCDTSearchContext context) ;
    List<EAMPlanCDT> selectByEamplanid(String eamplanid) ;
    void removeByEamplanid(String eamplanid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMPlanCDT> getEamplancdtByIds(List<String> ids) ;
    List<EAMPlanCDT> getEamplancdtByEntities(List<EAMPlanCDT> entities) ;
}


